function J =objectivefunctionC(search_scalar,femmodel,n);
%OBJECTIVEFUNCTIONC - objective function that return a parameter for a certain function

conserve_loads=true;
%recover some parameters
optscal=femmodel.parameters.OptScal(n);
fit=femmodel.parameters.Fit(n);
control_type=femmodel.parameters.ControlType;
analysis_type=femmodel.parameters.AnalysisType;
solution_type=femmodel.parameters.SolutionType;
isstokes=femmodel.parameters.IsStokes;

%set current configuration
if (solution_type==DiagnosticSolutionEnum | solution_type==SteadystateSolutionEnum)
	if isstokes, femmodel=SetCurrentConfiguration(femmodel,DiagnosticStokesAnalysisEnum);
	else femmodel=SetCurrentConfiguration(femmodel,DiagnosticHorizAnalysisEnum); end
elseif (solution_type==BalancedthicknessSolutionEnum)
	femmodel=SetCurrentConfiguration(femmodel,BalancedthicknessAnalysisEnum);
else
	error('solution not implemented yet');
end

%Use search scalar to shoot parameter in the gradient direction:
[femmodel.elements,femmodel.nodes,femmmodel.vertices,femmodel.loads,femmodel.materials,femmodel.parameters]=InputControlUpdate(femmodel.elements,femmodel.nodes,femmodel.vertices,femmodel.loads,femmodel.materials,femmodel.parameters,search_scalar*optscal,0);

%Run diagnostic with updated inputs:
if (solution_type==DiagnosticSolutionEnum)
	femmodel=solver_diagnostic_nonlinear(femmodel,conserve_loads);  %true means we conserve loads at each diagnostic run
elseif (solution_type==SteadystateSolutionEnum)
	femmodel=diagnostic_core(femmodel);  %We need a 3D velocity!! (vz is required for the next thermal run)
elseif (solution_type==BalancedthicknessSolutionEnum)
	femmodel=solver_linear(femmodel);
else
	error('solution not implemented yet');
end

%Compute misfit for this velocity field
[femmodel.elements,femmodel.loads]=InputUpdateFromConstant(femmodel.elements,femmodel.nodes,femmodel.vertices, femmodel.loads,femmodel.materials,femmodel.parameters,fit,FitEnum);
J=CostFunction(femmodel.elements,femmodel.nodes,femmodel.vertices,femmodel.loads,femmodel.materials, femmodel.parameters);
